<?php

const MODX_API_MODE = true;
require dirname(__FILE__, 4) . '/index.php';

/** @var modX $modx */
$modx->getService('error', 'error.modError');
$modx->setLogLevel(modX::LOG_LEVEL_ERROR);
$modx->setLogTarget('FILE');

/* @var miniShop2 $miniShop2 */
$miniShop2 = $modx->getService('minishop2');
$miniShop2->loadCustomClasses('payment');

if (!class_exists('Dolyame')) {
    exit('Error: could not load payment class "Dolyame".');
}


/* @var msPaymentInterface|Dolyame $handler */
$handler = new Dolyame($modx->newObject(msPayment::class));

$orderId = $_REQUEST['order_id'];

$transactionInfo = $handler->getOrderInfo($orderId);
$currentTransaction = $modx->getObject(mspDolyameTransaction::class, ['order_id' => $orderId]);

$handler->updateTransaction($orderId, $transactionInfo);
if (
    in_array($transactionInfo['status'], ['waiting_for_commit', 'wait_for_commit', 'committed']) &&
    !in_array($currentTransaction->status, ['waiting_for_commit', 'wait_for_commit', 'committed'])) {

    $order = $modx->getObject(msOrder::class, ['id' => $orderId]);
    $handler->receive($order);
}

