<?php

class MspdolyameTransactionsManagerController extends modExtraManagerController
{
    public $Dolyame;

     public function initialize()
    {
        $this->Dolyame = $this->modx->getService('DolyamePage', 'DolyamePage', MODX_CORE_PATH . 'components/mspdolyame/model/');
        $properties = [
            'login',
            'password',
            'cert',
            'key',
            'prefix',
            'product_vat',
            'delivery_vat',
            'payment_method',
            'payment_object',
            'delivery_payment_object',
            'fiscalisation',
            'ffd120',
            'request_handler',
            'success_url',
            'fail_url',
        ];
        $output = [];
        foreach($properties as $key) {
            $setting = $this->modx->getObject('modSystemSetting', 'mspdolyame_'.$key);
            $output[$key] = $setting->get('value');

        }

        $this->Dolyame->config['settings'] = $output;

        parent::initialize();
    }

    /**
    * @return string
    */
    public function getPageTitle()
    {
        return $this->modx->lexicon('dolyame_transactions') . ' | Dolyame';
    }


    /**
    * @return array
    */
    public function getLanguageTopics()
    {
        return array('mspdolyame:default', 'mspdolyame:transactions');
    }

    /**
    *
    */
    public function loadCustomCssJs()
    {

        $this->addJavascript($this->Dolyame->config['jsUrl'] . 'mgr/dolyame.js');

        $this->addJavascript(MODX_ASSETS_URL . 'components/minishop2/js/mgr/misc/ms2.utils.js');
        $this->addJavascript($this->Dolyame->config['jsUrl'] . 'mgr/transactions/transactions.form.js');
        $this->addJavascript($this->Dolyame->config['jsUrl'] . 'mgr/transactions/transactions.grid.js');
        $this->addJavascript($this->Dolyame->config['jsUrl'] . 'mgr/transactions/transactions.grid.products.js');
        $this->addJavascript($this->Dolyame->config['jsUrl'] . 'mgr/transactions/transactions.panel.js');
        $this->addJavascript($this->Dolyame->config['jsUrl'] . 'mgr/transactions/transactions.js');
        $this->addJavascript($this->Dolyame->config['jsUrl'] . 'mgr/transactions/transactions.accept.window.js');
        $this->addJavascript($this->Dolyame->config['jsUrl'] . 'mgr/transactions/transactions.refund.window.js');


        $this->addJavascript(MODX_MANAGER_URL . 'assets/modext/util/datetime.js');




        $config = $this->Dolyame->config;

        $this->addHtml('
            <script>
                Dolyame.config = ' . json_encode($config) . ';

                Ext.onReady(function() {
                    MODx.add({xtype: "dolyame-page-transactions"});
                });
            </script>');
    }
}
