<?php

class MspDolyameGetProductsProcessor extends modObjectGetListProcessor
{
    public $objectType = 'mspDolyameTransaction';
    public $classKey = 'mspDolyameTransaction';
    public $defaultSortField = 'id';
    public $defaultSortDirection = 'DESC';

    
    /**
     * We do a special check of permissions
     * because our objects is not an instances of modAccessibleObject
     *
     * @return boolean|string
     */
    public function beforeQuery()
    {
        if (!$this->checkPermissions()) {
            return $this->modx->lexicon('access_denied');
        }

        return true;
    }


    /**
     * @param xPDOQuery $c
     *
     * @return xPDOQuery
     */
    public function prepareQueryBeforeCount(xPDOQuery $c)
    {
        $id = trim($this->getProperty('id'));
        if ($id) {
            $c->where([
                'id' => $id,
            ]);
        }

        return $c;
    }


    public function outputArray(array $array,$count = false) {
        $array = json_decode($array[0]['items'], true);
        $array = array_map(function($key, $item) {
            $item['id'] = $key;
            return $item;
        }, array_keys($array), $array);
        $output = json_encode(array(
            'success' => true,
            'total' => count($array),
            'results' => $array
        ));
        if ($output === false) {
            $this->modx->log(modX::LOG_LEVEL_ERROR, 'Processor failed creating output array due to JSON error '.json_last_error());
            return json_encode(array('success' => false));
        }
        return $output;
    }

}

return 'MspDolyameGetProductsProcessor';